﻿Or_SoulShards = AceLibrary("AceAddon-2.0"):new("AceConsole-2.0", "AceEvent-2.0", "AceDB-2.0", "FuBarPlugin-2.0")
 
local Tablet = AceLibrary("Tablet-2.0")
Or_SoulShards:RegisterChatCommand({"/orss", "/or"}, options)

Or_SoulShards:RegisterDB("Or_SoulShardsDB")
Or_SoulShards:RegisterDefaults('char', {
	drop = true,
	extendedText = false,
	maxSoulsInBag = 28,
	maxSlider = 28,
	test = 0;
})

Or_SoulShards.hasIcon = true;
Or_SoulShards.clickableTooltip = true
Or_SoulShards.defaultPosition = "CENTER"

local maxSouls = 99; -- constant
local shardCount = -1;
local soulShard = "Soul shard";
local soulShardID = "6265";

function Or_SoulShards:OnInitialize()
    -- Called when the addon is loaded
    seterrorhandler(ErrorWithStack)
end

function Or_SoulShards:OnEnable()
	-- Called when the addon is enabled
	self:RegisterEvent("BAG_UPDATE")
end

function Or_SoulShards:OnDisable()
    -- Called when the addon is disabled
    self:UnRegisterEvent("BAG_UPDATE")
end

function ErrorWithStack(msg)
   msg = msg.."\n"..debugstack()
   _ERRORMESSAGE(msg)
end

function Or_SoulShards:BAG_UPDATE()
	self:Update()
end

function Or_SoulShards:OnClick()
	-- do something
	OrSSOptions:Show()
	-- self:Print(string.format("You currently have %d shards in your bags.", shardCount))
end

-- REGION UPDATE

function Or_SoulShards:OnDataUpdate()
	Or_SoulShards.db.char.test = Or_SoulShards.db.char.test + 1
	Or_SoulShards:CountAndDrop()
end
 
function Or_SoulShards:OnTextUpdate()
	s = ""
	if Or_SoulShards.db.char.extendedText then
	    s = "Soul shards: "
    end
    s = s .. string.format("%d", shardCount)
    s = s .. string.format(" (%d)", Or_SoulShards.db.char.maxSoulsInBag)
    -- s = s .. string.format("; Test num: %d", Or_SoulShards.db.char.test)
    
    self:SetText(s)
end
 
function Or_SoulShards:CountAndDrop()
	newCount = 0
	local bag = 4
	local s=""
	while(bag >= 0) do
    --for bag = 0, 4 do
		for slot=1,GetContainerNumSlots(bag) do
			if (GetContainerItemLink(bag,slot)) then
				local itemName = GetContainerItemLink(bag,slot)
				if (string.find(itemName, soulShardID)) then
					newCount = newCount + 1
					if (Or_SoulShards.db.char.drop) then
						if (newCount > Or_SoulShards.db.char.maxSoulsInBag) then
							s = "Dropping " .. itemName
							-- if s ~= "" then
								-- DEFAULT_CHAT_FRAME:AddMessage(s)
							-- end
							PickupContainerItem(bag,slot) 
							DeleteCursorItem()
							newCount = newCount - 1
						end
					end
				end
			end
		end
		bag = bag - 1
	end
	if newCount ~= shardCount then
		shardCount = newCount
	end
 end

-- REGION MENU

Or_SoulShards.OnMenuRequest = {
	type = 'group',
	--pass = true,
	args = {
		 drop = {
			type = "toggle",
			name = "Drop",
			desc = "Toggles whether excesive soul shards will be dropped or not",
			get = "IsDropValue",
			set = "ToggleDropValue",
		},
        --extendedtext = {
            --type = 'toggle',
            --name = "Extended text",
            --desc = "Show extended text",
			--get = function() return Oreka_SoulShards.db.char.extendedText end,
            --set = "ToggleExtendedText",
        --},
    }
}
--
function Or_SoulShards:IsDropValue()
   return Or_SoulShards.db.char.drop
end
 
function Or_SoulShards:ToggleDropValue()
   Or_SoulShards.db.char.drop = not Or_SoulShards.db.char.drop
   self:Update()
end

local tablet = AceLibrary("Tablet-2.0")
function Or_SoulShards:OnTooltipUpdate()
   local cat = tablet:AddCategory(
       'text', "",
       'columns', 2,
       'child_textR', 1,
       'child_textG', 1,
       'child_textB', 0,
       'child_textR2', 1,
       'child_textG2', 1,
       'child_textB2', 1
   )
   cat:AddLine(
       'text', "Soul Shards",
       'text2', shardCount .. " (" .. Or_SoulShards.db.char.maxSoulsInBag .. ")"
   )
   
   tablet:SetHint("Click to show options")
end
